<template lang="pug">
.connect.is-flex
	container
		.bg.img.is-flex
			img( v-lazy='require("@/assets/img/wallets.webp")' )
		.wrap.is-flex.is-align-items-center.is-justify-content-center
			.title-wrap
				title-bar( :content='$t("page.login.title")' )
				.btns-wrapper
					buttons( :vertical='isPhone || isTablet' )
						b-button( asset="walletconnect" :width='271' :fullwidth='isPhone || isTablet' @click="connect('walletconnect')") Walletconnect
						b-button( asset="metamask" type="yellow" :width='271' :fullwidth='isPhone || isTablet' @click="connect('injected')") Metamask
</template>

<script lang="ts">
import MainMixin from "../mixins/Main";
import { ProviderController } from "../store/web3connector/ProviderController";
import Component from "vue-class-component";

@Component
export default class Login extends MainMixin {
  private providerController = new ProviderController(this.$store.getters["Web3Module/providerOptions"]);
  private atAccountChange = false;
  error = false;
  hasInjected = false;

  get isAuthorized() {
    return this.$store.getters["Web3Module/isAuthorized"];
  }

  async onAccountChanged(newAccount: string) {
    console.log(newAccount);
    this.atAccountChange = true;
    await this.init();
    await this.$store.dispatch("Web3Module/reset", true);
    await this.connectWeb3(this.$store.getters["Web3Module/providerId"]);
    this.atAccountChange = false;
    return this.$notify({
      title: "Account changed",
      text: newAccount,
      type: "success",
    });
  }
  async onChainIdChanged(newChainId: number) {
    console.log(newChainId, this.$store.getters["Web3Module/targetChainId"]);
    if (newChainId !== this.$store.getters["Web3Module/targetChainId"]) {
      this.$notify({
        title: "Bad network",
        text: "Please choose BNB Smart Chain network",
        type: "error",
      });
    }
  }

  async connectWeb3(id: string) {
    await this.$store.dispatch("Web3Module/connect", {
      id,
      onAccountChangedCallback: (newAccount: string) => {
        this.onAccountChanged(newAccount);
      },
      onChainIdChangedCallback: (newChainId: number) => {
        this.onChainIdChanged(newChainId);
      },
      onConnectCallback: async () => {
        await this.init();
        if (!this.$route.path.match(/profile|admin/)) this.$router.push({ name: "Profile" });
      },
    });
  }

  async init() {
    console.log(`init from login`);
    await Promise.all([
      this.$store.dispatch("UserModule/getUser", this.$store.getters["Web3Module/account"]),
    ]);
  }

  async connect(id: string) {
    if (!this.hasInjected && id === "injected") {
      return this.$notify({
        title: "Please, install metamask first",
        type: "error",
      });
    }
    await this.connectWeb3(id);
  }

  async created() {
    const providers = this.providerController.getDisplayProviders();
    if (providers.length > 0 && providers.find((p) => p?.id === "injected") !== undefined) this.hasInjected = true;
  }
}
</script>

<style lang="scss" scoped>
.section::v-deep {
	.container {
		height: 100%;
	}
}

.bg {
	width: 24rem;
	position: absolute;
	top: 0;
	right: 0;
	@include max_tablet {
		width: 12.9rem;
		top: 5rem;
		right: -2rem;
	}
}

.wrap {
	height: 100%;
	width: 100%;
	position: relative;
	z-index: 2;
}

.title-wrap {
	width: 100%;
}

.connect {
	.btns-wrapper {
		display: inline-flex!important;
		margin: 1.3125rem 0 0;
		padding: 1.625rem;
		background: rgba($color: #fff, $alpha: .06);
		border-radius: 15px;
		@include max_tablet {
			display: flex!important;
			max-width: 400px;
			margin: 1.3125rem auto 0;
		}
	}
}

.btns::v-deep {
	width: calc(100% + .9rem);
	.btn {
		&:first-of-type {
			margin-right: 0;
			.content-wrapper {
				.img {
					width: 1.875rem;
				}
			}
			@include max_tablet {
				margin-right: .45rem;
			}
		}
		&:last-of-type {
			margin-left: 3.71125rem;
			.content-wrapper {
				.img {
					width: 2.125rem;
				}
			}
			@include max_tablet {
				margin-left: .45rem;
			}
		}
	}
}
</style>